#!/usr/bin/env python

import sys

gms = 39.47841760
M_S = 1.989e30
M_E = 5.972e24
tmp = 1.0/gms*M_S/M_E

f = sys.stdin
f2 = open("coll.out", "w")
f2.write("# t [yr] & m1 [M_E] & m2 [M_E] & m1+m2 [M_E]\n")

tlast = 0.0
M = []
M2 = []
j = 0
for line in f.readlines():
    l = line.split()
    t = float(l[1])
    m = round(float(l[8])*tmp,4)
    if t == tlast:
        M.append(m)
    else:
        if len(M) != len(M2) and t > 0.0:
            M3 = []
            Mtmp = []
            for i in xrange(0,len(M)):
                Mtmp.append(M[i])
            for i in xrange(0,len(M2)):
                try:
                    Mtmp.remove(M2[i])
                except ValueError:
                    M3.append(M2[i])

            M3.sort(reverse=True)
            if len(M3) >= 2:
                j += 1
                f2.write("%2d  %.8e  %.4f %.4f  %.4f\n" % (j, t, M3[0], M3[1], M3[0]+M3[1]))
            if len(M3) >= 4:
                j += 1
                f2.write("%2d  %.8e  %.4f %.4f  %.4f\n" % (j, t, M3[2], M3[3], M3[2]+M3[3]))

            if len(M3) > 0:
                print "========"
                print "j = ", j
                print "t = ", t
                print "len(M) = ", len(M)
                print "len(M2) = ", len(M2)
                print "M3 = ", M3
                print line
#                print "M4 = ", M4

        M2 = []
        for i in xrange(0,len(M)):
            M2.append(M[i])
        M = []
        M.append(m)

    tlast = t
#    if t > 10.0e6:
#         break
        

f.close()
f2.close()


